#include "RunGame.h"

RunGame::RunGame()
{
	memset(left_global_pos, 0, 3 * sizeof(float));

	memset(right_global_pos, 0, 3 * sizeof(float));

	down_wait_after_jump = -1;

	last_left_zupt = 1;
	last_right_zupt = 1;

	last_canva_down = 0;
}




void RunGame::Process(int time_stamp, int* right_pos, int* right_att, int* right_acc, int right_zupt, int right_front_press, int right_back_press,
	int* left_pos, int* left_att, int* left_acc, int left_zupt, int left_front_press, int left_back_press,
	int jump, int down, int rssi)
{


	int left_cmd = -1;
	int right_cmd = -1;

	if (left_roll_vec.size() == 0)
	{
		left_roll_vec.push_back(left_att[2]);
	}
	else
	{
		if (left_att[2] >= left_roll_vec.back())
		{
			left_roll_vec.push_back(left_att[2]);
		}
		else
		{
			left_roll_vec.clear();
		}
	}

	if (right_roll_vec.size() == 0)
	{
		right_roll_vec.push_back(right_att[2]);
	}
	else
	{
		if (right_att[2] >= right_roll_vec.back())
		{
			right_roll_vec.push_back(right_att[2]);
		}
		else
		{
			right_roll_vec.clear();
		}
	}

	if (right_roll_vec.size() > 9 && left_roll_vec.size() > 9)
	{
		int right_dist = right_roll_vec.back() - right_roll_vec.front();

		int left_dist = left_roll_vec.back() - left_roll_vec.front();

		if (right_dist > 800 && left_dist > 800)
		{
			if (right_dist > 2000 || left_dist > 2000)
			{
				std::cout << "right_dist : " << right_dist << " left_dist :" << left_dist << endl;
				if (right_dist > left_dist + 500)
				{
					right_cmd = MOTION_RIGHT;
				}
				else if (left_dist > right_dist + 500)
				{
					left_cmd = MOTION_LEFT;
				}
			}
		}
	}

	result[0] = -1;

	if (left_cmd != last_left_cmd && left_cmd == MOTION_LEFT)
	{
		result[0] = MOTION_LEFT;
	}

	result[1] = -1;
	if (right_cmd != last_right_cmd && right_cmd == MOTION_RIGHT)
	{
		result[1] = MOTION_RIGHT;
	}

	last_left_cmd = left_cmd;
	
	last_right_cmd = right_cmd;


	////һĿݵshoes_data_vector У ͷǴʱϢ
	//setData(right_shoes_data_vector, time_stamp, right_pos[0] * 0.001f, right_pos[1] * 0.001f, right_pos[2] * 0.001f,
	//	right_att[0] * 0.0001f, right_att[1] * 0.0001f, right_att[2] * 0.0001f, right_zupt, rssi);

	//setData(left_shoes_data_vector, time_stamp, left_pos[0] * 0.001f, left_pos[1] * 0.001f, left_pos[2] * 0.001f,
	//	left_att[0] * 0.0001f, left_att[1] * 0.0001f, left_att[2] * 0.0001f, left_zupt, rssi);

	////ȫλãѡǰתΪһʱķ򣬶תΪ10
	////hoes_data_vectorЬϴݣķЬ¼ʱķ򣬲ϷʱķҪתϷķ
	////step_data_vector λѾѡϷķˣλλƣleft_step_data_vector[0]λƫ
	//calGlobalPos(right_shoes_data_vector, right_step_data_vector, right_global_pos, right_shoes_data_vector[0].heading, 10.0f / 180 * PI, RIGHT_FOOT);
	//calGlobalPos(left_shoes_data_vector, left_step_data_vector, left_global_pos, left_shoes_data_vector[0].heading, -10.0f / 180 * PI, LEFT_FOOT);

	////Ϊ˽ű׹۲⣬ȫλΪ0
	//if (left_step_data_vector.front().zupt == 0)
	//{
	//	memset(left_global_pos, 0, 3 * sizeof(float));
	//}

	//if (right_step_data_vector.front().zupt == 0)
	//{
	//	memset(right_global_pos, 0, 3 * sizeof(float));
	//}

	//if (left_step_data_vector.size() > 100)
	//{
	//	left_step_data_vector.pop_front();
	//}

	//if (right_step_data_vector.size() > 100)
	//{
	//	right_step_data_vector.pop_front();
	//}


	////ж
	//int left_cmd = -1;
	//if (left_step_data_vector.size() > 1 && left_step_data_vector.front().zupt == 1)
	//{
	//	//ܿϷֻҪпеݣϷһҪʱжϾͺãҪϷ
	//	if (left_step_data_vector.back().zupt || left_step_data_vector.back().pitch < 0.3f)
	//	{
	//		//ܲӲҪܣô͵ȵصʱж

	//		float max_val = left_step_data_vector.front().pos_x;

	//		for (int i = 0; i < left_step_data_vector.size(); i++)
	//		{
	//			if (left_step_data_vector[i].pos_x > max_val)
	//			{
	//				max_val = left_step_data_vector[i].pos_x;
	//			}
	//		}

	//		int roll_valid = 0;
	//		float front_roll = left_step_data_vector.front().roll;
	//		for (int i = 1; i < left_step_data_vector.size(); i++)
	//		{
	//			if (left_step_data_vector[i].roll > left_step_data_vector[i - 1].roll - 0.000001f)
	//			{
	//				if (left_step_data_vector[i].roll - front_roll > 0.3f)
	//				{
	//					roll_valid = 1;
	//				}
	//				continue;
	//			}
	//			front_roll = left_step_data_vector[i].roll;
	//		}
	//		

	//		//ЧΪ0.23m
	//		if (max_val - left_step_data_vector.back().pos_x > 0.23f && roll_valid)
	//		{
	//			if (!(rssi_delay.size() > 0 && rssi < 25 && rssi_delay.front() > 32))
	//			{
	//				left_cmd = MOTION_LEFT;
	//				std::cout << "motion: left_side, " << left_step_data_vector.back().pitch << std::endl;
	//			}

	//			left_step_data_vector.pop_front();
	//		}
	//	}
	//}

	//int right_cmd = -1;
	//if (right_step_data_vector.size() > 1 && right_step_data_vector.front().zupt == 1)
	//{

	//	if (right_step_data_vector.back().zupt || right_step_data_vector.back().pitch < 0.3f)
	//	{

	//		float min_val = right_step_data_vector.front().pos_x;

	//		for (int i = 0; i < right_step_data_vector.size(); i++)
	//		{
	//			if (right_step_data_vector[i].pos_x < min_val)
	//			{
	//				min_val = right_step_data_vector[i].pos_x;
	//			}
	//		}

	//		int roll_valid = 0;
	//		float front_roll = right_step_data_vector.front().roll;
	//		for (int i = 1; i < right_step_data_vector.size(); i++)
	//		{
	//			if (right_step_data_vector[i].roll > right_step_data_vector[i - 1].roll - 0.000001f)
	//			{
	//				if (right_step_data_vector[i].roll - front_roll > 0.3f)
	//				{
	//					roll_valid = 1;
	//				}
	//				continue;
	//			}
	//			front_roll = right_step_data_vector[i].roll;
	//		}

	//		if (right_step_data_vector.back().pos_x - min_val > 0.23f && roll_valid)
	//		{
	//			if (!(rssi_delay.size() > 0 && rssi < 25 && rssi_delay.front() > 32))
	//			{
	//				right_cmd = MOTION_RIGHT;

	//				std::cout << "motion: right_side, " << left_step_data_vector.back().pitch << std::endl;
	//			}
	//			right_step_data_vector.pop_front();
	//		}
	//	}
	//}



	//result[0] = left_cmd;

	//result[1] = right_cmd;

	result[2] = getResultJump(jump);

	result[3] = getResultDown(down);

	//result[2] = left_zupt;

	//result[3] = right_zupt;


	left_acc_deque.push_back(left_acc[2]);
	right_acc_deque.push_back(right_acc[2]);

	if (left_acc_deque.size() > 5)
	{
		left_acc_deque.pop_front();
		right_acc_deque.pop_front();
	}

	int acc_valid = 0;
	if (left_acc_deque.size() == 5)
	{
		int left_max_val = *(std::max_element(left_acc_deque.begin(), left_acc_deque.end()));
		int left_min_val = *(std::min_element(left_acc_deque.begin(), left_acc_deque.end()));

		int right_max_val = *(std::max_element(right_acc_deque.begin(), right_acc_deque.end()));
		int right_min_val = *(std::min_element(right_acc_deque.begin(), right_acc_deque.end()));


		if (left_max_val - left_min_val < 512 && right_max_val - right_min_val < 512)
		{
			acc_valid = 1;
		}
	}


	//һвܴ׵
	/*if (left_zupt == 0 && right_zupt == 0 && down_wait_after_jump > 0)
	{
		down_wait_after_jump = 10;
	}*/

	//Ʋ
	if (last_left_zupt == 0 && left_zupt == 1 && unzuptValid(max_acc_unzupt_left, min_acc_unzupt_left))
	{
		addMotionCount(STEP_COUNT);
	}

	if (last_right_zupt == 0 && right_zupt == 1 && unzuptValid(max_acc_unzupt_right, min_acc_unzupt_right))
	{
		addMotionCount(STEP_COUNT);
	}

	setPolarAccUnzupt(max_acc_unzupt_left, min_acc_unzupt_left, left_acc, left_zupt);
	setPolarAccUnzupt(max_acc_unzupt_right, min_acc_unzupt_right, right_acc, right_zupt);

	last_left_zupt = left_zupt;
	last_right_zupt = right_zupt;

}

int RunGame::getResultDown(int down)
{
	int isDown = -1;

	if (last_down == 0 && down > 0)
	{
		isDown = MOTION_DOWN;

		addMotionCount(DOWN_COUNT);

		std::cout << "motion : down" << std::endl;

		//down_count++;
	}

	last_down = down;

	return isDown;

}

int RunGame::getResultJump(int jump)
{
	int isJump = -1;

	if (last_jump == 0 && jump == 1)
	{
		isJump = MOTION_JUMP;

		addMotionCount(JUMP_COUNT);

		std::cout << "motion : jump" << std::endl;

		jump_count++;
	}

	last_jump = jump;

	return isJump;
}



void RunGame::setStepHeading(float& cur_heading, float heading)
{
	cur_heading = heading;
}
